#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void print (const vector<char>& menge)
{
    /* Elemente der Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<char>(cout));
    cout << endl;
}

int main()
{
    vector<char>::iterator pos;

    /* Vorlagen-Menge:
     *  "..........abcdef.........."
     */
    vector<char> vorlage(10,'.');
    for (int c='a'; c<='f'; c++) {
        vorlage.push_back(c);
    }
    vorlage.insert(vorlage.end(),10,'.');

    print (vorlage);

    // RICHTIG:

    /* Buchstaben drei Elemente vor das 'a' kopieren
     * und ausgeben
     */
    vector<char> m1(vorlage.begin(),vorlage.end());
    pos = find (m1.begin(), m1.end(), 'a');
    copy (pos, pos+6, pos-3);
    print (m1);

    /* Buchstaben drei Elemente hinter das 'f' kopieren
     * und ausgeben
     */
    vector<char> m2(vorlage.begin(),vorlage.end());
    pos = find (m2.begin(), m2.end(), 'a');
    copy_backward (pos, pos+6, pos+9);
    print (m2);

    // FALSCH:

    /* Buchstaben drei Elemente vor das 'a' kopieren
     * und ausgeben
     */
    vector<char> m3(vorlage.begin(),vorlage.end());
    pos = find (m3.begin(), m3.end(), 'a');
    copy_backward (pos, pos+6, pos+3);
    print (m3);

    /* Buchstaben drei Elemente hinter das 'f' kopieren
     * und ausgeben
     */
    vector<char> m4(vorlage.begin(),vorlage.end());
    pos = find (m4.begin(), m4.end(), 'a');
    copy (pos, pos+6, pos+3);
    print (m4);
}
