#include <iostream>
#include <map>
#include <string>
#include <iomanip>
using namespace std;

int main()
{
    /* Multi-Map fuer String-Schluessel und
     * String-Wert als Typ definieren
     */
    typedef multimap<string,string> StrStrMMap;

    /* eine leere Multimap als Woerterbuch anlegen
     */
    StrStrMMap wbuch;

    /* einige Elemente einzeln einfuegen
     */
    wbuch.insert (StrStrMMap::value_type("day","Tag"));
    wbuch.insert (StrStrMMap::value_type("strange","fremd"));
    wbuch.insert (StrStrMMap::value_type("car","Auto"));
    wbuch.insert (StrStrMMap::value_type("smart","elegant"));
    wbuch.insert (StrStrMMap::value_type("trait","Merkmal"));
    wbuch.insert (StrStrMMap::value_type("strange","seltsam"));
    wbuch.insert (StrStrMMap::value_type("smart","raffiniert"));
    wbuch.insert (StrStrMMap::value_type("smart","klug"));
    wbuch.insert (StrStrMMap::value_type("clever","raffiniert"));

    /* alle Elemente ausgeben
     */
    StrStrMMap::iterator pos;
    cout.setf (ios::left, ios::adjustfield);
    for (pos = wbuch.begin(); pos != wbuch.end(); ++pos) {
        cout << "englisch: " << setw(10) << pos->first
             << "deutsch: "  << pos->second << endl;
    }

    /* alle Schluessel zum Wert "smart" ausgeben
     */
    string wort("smart");
    cout << wort << ": " << endl;
    for (pos = wbuch.lower_bound(wort);
         pos != wbuch.upper_bound(wort); ++pos) {
        cout << "    " << pos->second << endl;
    }

    /* alle Werte zum Schluessel "raffiniert" ausgeben
     */
    wort = ("raffiniert");
    cout << wort << ": " << endl;
    for (pos = wbuch.begin(); pos != wbuch.end(); ++pos) {
        if (pos->second == wort) {
            cout << "    " << pos->first << endl;
        }
    }
}
