#include <iostream>
#include <list>
#include <algorithm>
#include <cstdlib>      // fuer abs()
using namespace std;

/* Funktion, die zurueckliefert, ob eine
 * uebergebene Zahl eine Primzahl ist
 */
bool istPrimzahl (int zahl)
{
    int teiler;

    // negative Zahlen zum Testen negieren
    zahl = abs(zahl);

    // Sonderfaelle 0 und 1
    if (zahl == 0 || zahl == 1) {
        return true;
    }
        
    /* ab Haelfte der Zahl absteigend
     * Teiler ohne Rest suchen
     */
    for (teiler = abs(zahl)/2; zahl%teiler != 0; teiler--) {
        ;
    }
    return teiler == 1;
}

int main()
{
    list<int> menge;

    /* Elemente 24 bis 30 in die Menge einfuegen
     */
    for (int i=24; i<=30; i++) {
        menge.push_back(i);
    }

    /* Primzahl suchen
     */
    list<int>::iterator pos;
    pos = find_if (menge.begin(), menge.end(),  // Bereich
                   istPrimzahl);                // Suchbedingung
    if (pos != menge.end()) {
        // gefunden
        cout << *pos << " ist erste gefundene Primzahl" << endl;
    }
    else {
        // nicht gefunden
        cout << "keine Primzahl gefunden" << endl;
    }
}
