#include <iostream>
#include <memory>
using namespace std;

/* Ausgabe-Operator fuer Auto-Pointer definieren
 *  - gibt Wert des Objekts oder NULL aus
 */
template <class T>
ostream& operator << (ostream& strm, const auto_ptr<T>& p)
{
    if (p.get() == NULL) {      // Objekt vorhanden ?
        strm << "NULL";         //  NEIN: NULL ausgeben
    }
    else {
        strm << *p;             //  JA: mit * darauf zugreifen
    }                           //      und ausgeben
    return strm;
}

int main()
{
    auto_ptr<int> p = new int(42);
    auto_ptr<int> q;

    cout << "nach Initialisierung:" << endl;
    cout << " p: " << p << endl;
    cout << " q: " << q << endl;

    q = p;
    cout << "nach Zuweisung:" << endl;
    cout << " p: " << p << endl;
    cout << " q: " << q << endl;

    *q += 13;                   // Wert des Auto-Pointer-Objekts erhoehen
    p = q;
    cout << "nach Aenderung und Rueck-Zuweisung:" << endl;
    cout << " p: " << p << endl;
    cout << " q: " << q << endl;
}
